#ifndef LAZYCREATION_H
#define LAZYCREATION_H
#include <stdio.h>

/********************************************************
This is an exmple for the Designpattern (Entwurfsmuster)
LazyCreation. Only one instance of the class may be 
generated by calling the function getInstance.
********************************************************/

class LazyCreation
{

private:
	// the constructor is private, therefore 
	// an instance only may be generated by calling the
	// function getInstance()

	LazyCreation(){
	}

public:
	// getInstance is the function which returns a pointer
	// to the only instance which exists.
	static LazyCreation* getInstance()
	{
		static LazyCreation myInstance;
		return &myInstance;
	}
	// a print function for testing the getInstance function
	void print()
	{
		printf("Ja,funktioniert!\n");
	}
};


#endif